import gtk
import math
import pango
from Table import Table
from Point import Point


class Ball :

   def __init__(self, a_position_x, a_position_y, a_color, a_number) :

      self.position_x = a_position_x
      self.position_y = a_position_y
      self.color = a_color
      self.number = a_number
      self.speed = 0.0
      self.radius = 9
      self.radiusx2 = self.radius * 2
      self.radian = 0.0
      self.ball_in_hole = False
      self.sight_point = Point(0, 0)

   def move_to(self, point) :

      self.position_x = point.x
      self.position_y = point.y

   def move(self, a_table, balls) :

      ball_is_moving = True
      if self.speed >= 1 :

         if self.speed > 10 :
            self.speed -= 0.5

         else  :
            self.speed -= 0.1

         for i in range(int(self.speed)) :

            self.position_x += math.cos(self.radian)
            self.position_y += math.sin(self.radian)
            self.contains_point(a_table, balls)

      else  :

         self.speed = 0
         ball_is_moving = False
         self.sight_point = Point(0, 0)

      return ball_is_moving


   def contains_point(self, a_table, balls) :

      old_speed = self.speed
      x = math.cos(self.radian)
      y = math.sin(self.radian)
      is_crashed = False

      # TUTKITAAN PALLOT
      for index in range(len(balls)) :

         # EI TESTATA OMAA PALLOA
         if self.number != balls[index].number :

            # JOS JOKU PALLO OSUU OMAAN PALOON
            if balls[index].position_x < self.position_x + self.radiusx2 and \
               balls[index].position_x > self.position_x - self.radiusx2 and \
               balls[index].position_y < self.position_y + self.radiusx2 and \
               balls[index].position_y > self.position_y - self.radiusx2 and \
               math.hypot(balls[index].position_x - self.position_x,
                          balls[index].position_y - self.position_y) < self.radius * 2 :

               speed2 = balls[index].speed
               total_speed = old_speed + speed2

               # OMA PALLO VAHVEMPI
               if old_speed > speed2 :

                  # HEIKOMPI PALLO SAA RADIAANIN SUORAAN PALLOISTA
                  radian2 = math.atan2(balls[index].position_y - self.position_y, balls[index].position_x - self.position_x)

                  balls[index].set_radian(radian2)

                  # OTETAAN SELVILLE HEIKOMMAN PALLON VAAKA- JA PYSTYLIIKE
                  x2 = math.cos(radian2)
                  y2 = math.sin(radian2)

                  # VAHVEMPI PALLO SAA RADIAANIN
                  if y - y2 == 0 and x - x2 == 0 :

                     self.radian = math.atan2(-y, -x)

                  else  :

                     self.radian = math.atan2(y - y2, x - x2)

                  balls[index].set_speed(abs(x2) * abs(x) * old_speed + abs(y2) * abs(y) * old_speed)

                  self.speed = abs(math.cos(self.radian)) * abs(x) * (total_speed - balls[index].speed) \
                             + abs(math.sin(self.radian)) * abs(y) * (total_speed - balls[index].speed)

                  if  self.sight_point.x != 0 or self.sight_point.y != 0 :

                     # YLA JA ALAKIERRE
                     # SUMMATAAN YHTEEN ALKUPERAINEN VEKTORI SIGHT Y:n VOIMALLA
                     # JA NYKYINEN VEKTORI

                     new_x =  self.sight_point.y / 2.5 * x + self.speed * math.cos(self.radian)
                     new_y =  self.sight_point.y / 2.5 * y + self.speed * math.sin(self.radian)

                     self.radian = math.atan2(new_y, new_x)

                     self.speed = abs(new_x) + abs(new_y)

                     if self.speed > old_speed :

                        self.speed = old_speed - 0.5


                  is_crashed = True

               elif old_speed < speed2 :

                  # HEIKOMPI PALLO SAA RADIAANIN SUORAAN PALLOISTA
                  self.radian = math.atan2(self.position_y - balls[index].position_y,
                                           self.position_x - balls[index].position_x)

                  # OTETAAN SELVILLE HEIKOMMAN PALLON VAAKA- JA PYSTYLIIKE
                  x_new = math.cos(self.radian)
                  y_new = math.sin(self.radian)

                  # OTETAAN SELVILLE VAHVEMMAN PALLON VAAKA- JA PYSTYLIIKE
                  x2 = math.cos(balls[index].radian)
                  y2 = math.sin(balls[index].radian)

                  # VAHVEMPI PALLO SAA RADIAANIN
                  if y2 - y_new == 0 and x2 - x_new == 0 :

                     balls[index].set_radian(math.atan2(-y2, -x2))

                  else  :

                     balls[index].set_radian(math.atan2(y2 - y_new, x2 - x_new))


                  # OTETAAN SELVILLE VAHVEMMAN PALLON UUSI VAAKA- JA PYSTYLIIKE
                  x2_new = math.cos(balls[index].radian)
                  y2_new = math.sin(balls[index].radian)
                  old_speed2 = balls[index].speed

                  # VOIMAT
                  balls[index].set_speed(abs(x2) * abs(x2_new) * old_speed2 + abs(y2) * abs(y2_new) * old_speed2)
                  self.speed = abs(math.cos(self.radian)) * abs(x2) * (total_speed - balls[index].speed) \
                             + abs(math.sin(self.radian)) * abs(y2) * (total_speed - balls[index].speed)

                  if balls[index].sight_point.x != 0 or balls[index].sight_point.y != 0 :

                     # YLA JA ALAKIERRE
                     # SUMMATAAN YHTEEN ALKUPERAINEN VEKTORI SIGHT Y:n VOIMALLA
                     # JA NYKYINEN VEKTORI

                     new_x = balls[index].sight_point.y / 2.5 * x2 + balls[index].speed * math.cos(balls[index].radian)
                     new_y = balls[index].sight_point.y / 2.5 * y2 + balls[index].speed * math.sin(balls[index].radian)

                     balls[index].set_radian(math.atan2(new_y, new_x))

                     new_speed = abs(new_x) + abs(new_y)

                     if new_speed > speed2 :

                        new_speed = speed2 - 0.5

                     balls[index].set_speed(new_speed)

                  is_crashed = True


      # TUTKITAAN TORMAYSSEINAT JA REIAT (jos pallo on sallitus rajan ulkopuolella)
      if self.position_x < 50 + self.radius * 2 or \
         self.position_y < 60 + self.radius * 2 or \
         self.position_x > 650 - self.radius * 2 or \
         self.position_y > 360 - self.radius * 2 :

         # TUTKITAAN TORMAYSSEINAT
         for index in range(6) :

            if index == 4 or index == 5 :

               # TORMAYSSEINAT LEFT JA RIGHT
               if a_table.edges[index].path.intersects( \
                     self.position_x - self.radius, self.position_y - 1, self.radius * 2, 1) :
                  self.radian = math.atan2(y, -x)
                  is_crashed = True

            else  :

               # TORMAYSSEINAT TOP JA BOTTOM
               if a_table.edges[index].path.intersects(self.position_x - 1,
                     self.position_y - self.radius, 1, self.radius * 2) :
                  self.radian = math.atan2(-y, x)
                  is_crashed = True




         # TUTKITAAN REIAT
         for index in range(6) :

            crash = a_table.holes[index].contains_point(self)

            if crash == True :

               is_crashed = False



      if is_crashed == True :

         self.position_x -= x
         self.position_y -= y


   def draw( self, drawing_area) :

      graphics_context  = drawing_area.get_style().fg_gc[gtk.STATE_NORMAL]
      this_drawable  =  drawing_area.window

      #graphics.setColor(color)
      #graphics.fillOval((int) (position_x - self.radius),
      #                  (int) (self.position_y - self.radius),
      #                  (int) (self.radius * 2), (int) (self.radius * 2))

      graphics_context.set_rgb_fg_color(self.color)

      this_drawable.draw_arc( graphics_context, True,
                              int(self.position_x - self.radius),
                              int(self.position_y - self.radius),
                              int(self.radius * 2), int(self.radius * 2),
                              0, 360*64 )

      if self.number > 8 :

         # maalataan valkoinen raita

         #graphics.setColor(Color.white)
         #graphics.fill3DRect((int) (self.position_x - 3),
         #                    (int) (self.position_y - self.radius) + 1, 6,
         #                    (int) (self.radius * 2) - 2, True)

         graphics_context.foreground  =  \
            this_drawable.get_colormap().alloc_color( "white")

         this_drawable.draw_rectangle(graphics_context, True,
                                      int(self.position_x - 3),
                                      int(self.position_y - self.radius) + 1,
                                      6, int(self.radius * 2) - 2)

      #graphics.setColor(Color.black)
      graphics_context.foreground  =  \
         this_drawable.get_colormap().alloc_color( "black")
      text_to_show  =  drawing_area.create_pango_layout("")
      text_to_show.set_font_description(pango.FontDescription( "arial bold 9" ))
      if self.number < 10 :

         if self.number == 8 :

            graphics_context.foreground  =  \
                   this_drawable.get_colormap().alloc_color( "white")

         if self.number != 0 :
            #graphics.drawString("" + self.number, (int) self.position_x - 4,
            #                    (int) self.position_y + 4)
       
            text_to_show.set_text("%d"  % self.number)
            this_drawable.draw_layout( graphics_context, int(self.position_x - 4),
                                       int(self.position_y - 9), text_to_show )

      else  :

         #graphics.drawString("" + self.number, (int) self.position_x - 8,
         #                    (int) self.position_y + 4)

         text_to_show.set_text("%d"  %  self.number)
         this_drawable.draw_layout( graphics_context, int(self.position_x - 8),
                                       int(self.position_y - 9), text_to_show )


   def set_speed(self, a_speed) :

      self.speed = a_speed

      #print "pallon %d nopeus on %d" % (self.number, self.speed)

   def set_radian(self, a_radian) :

      self.radian = a_radian

   def set_radius(self, a_radius) :

      self.radius = a_radius

   def set_ball_in_hole(self, value) :

      self.ball_in_hole = value

   def set_sight_point(self, point) :

      self.sight_point = point


