
# Tama luokka piirtaa reiat ja tarkastaa onko reiissa palloja

import gtk
import sys
import math
from Point import Point
from GeneralPath import GeneralPath

class Hole :

   def __init__(self, a_hole_number, a_x, a_y) :

      self.hole_radius = 14
      self.hole_number = a_hole_number
      self.corner = GeneralPath()
      curve = Point(a_x - 20, a_y - 20)

      # reiat 1,3,4 ja 6
      # kolmas parametri lisatty -5 ja -5
      corner_x =  [36, 35, 15, -5, -10, 10, 10, -30, -30, 36]
      corner_y =  [10, 10, -10, -5, 15, 35, 36, 36, -30, -30]

      # reiat 2 ja 5
      #kolmas parametri lisatty 0 ja -15
      corner25_x =  [26, 25, 15, 0, -15, -25, -26, -26, 0, 26]
      corner25_y =  [10, 10, -10, -15, -10, 10, 10, -30, -30, -30]

      for i in range(len(corner_x)) :

         if self.hole_number == 1 :

            self.point = Point(a_x + 5, a_y + 5)

         if self.hole_number == 2 :

            corner_x[i] = corner25_x[i]
            corner_y[i] = corner25_y[i]

            curve.x = a_x
            curve.y = a_y - 20

            self.hole_radius = 5

            self.point = Point(a_x, a_y)

         elif self.hole_number == 3 :

            corner_x[i] *= -1
            curve.x = a_x + 20
            self.point = Point(a_x - 5, a_y + 5)

         elif self.hole_number == 4 :

            corner_y[i] *= -1
            curve.y = a_y + 20
            self.point = Point(a_x + 5, a_y - 5)

         elif self.hole_number == 5 :

            corner_x[i] = corner25_x[i]
            corner_y[i] = -corner25_y[i]

            curve.x = a_x
            curve.y = a_y + 20

            self.hole_radius = 5

            self.point = Point(a_x, a_y)

         elif self.hole_number == 6 :

            corner_x[i] *= -1
            corner_y[i] *= -1
            curve.x = a_x + 20
            curve.y = a_y + 20

            self.point = Point(a_x - 5, a_y - 5)



      self.corner.moveTo(corner_x[0] + a_x, corner_y[0] + a_y)
      for index in range(1, len(corner_x)) :

         self.corner.lineTo(corner_x[index] + a_x, corner_y[index] + a_y)

      self.corner.closePath()



   def draw(self, drawing_area) :

      graphics_context  = drawing_area.get_style().fg_gc[gtk.STATE_NORMAL]
      this_drawable  =  drawing_area.window

      graphics_context.foreground  =  \
                   this_drawable.get_colormap().alloc_color( "black")

      if self.hole_number == 2 or self.hole_number == 5 :

         this_drawable.draw_arc(graphics_context, True,
                                self.point.x - 20, self.point.y - 15, 40, 32,
                                0, 360*64 )

      else  :

         this_drawable.draw_arc(graphics_context, True,
                                self.point.x - 20, self.point.y - 20, 40, 40,
                                0, 360*64 )


      # debuggausta varten
      # graphics2D.setColor( Color.blue )
      # graphics2D.fill( self.corner )

      #graphics_context.foreground  =  \
      #             this_drawable.get_colormap().alloc_color( "blue")

      #self.corner.draw(drawing_area)


   def contains_point(self, ball) :

      # varmistetaan pallon sivuilta,ylhaalta/alhaalta sekA 45 asteen kulman
      # kohdilta

      ball_x_left_top = ball.position_x - ball.radius * math.pi / 4
      ball_y_left_top = ball.position_y - ball.radius * math.pi / 4
      w_and_h = ball.radius * math.pi / 2

      if self.corner.intersects(ball_x_left_top, ball_y_left_top, w_and_h, w_and_h) or \
         self.corner.intersects(ball.position_x - 1, ball.position_y - ball.radius, 1, ball.radius * 2) or \
         self.corner.intersects(ball.position_x - ball.radius, ball.position_y - 1, ball.radius * 2, 1) :

         x = self.point.x - ball.position_x
         y = self.point.y - ball.position_y
         ball.radian = math.atan2(y, x)

         # JARRUTETAAN PALLON NOPEUTTA
         if ball.speed > 2 :

            ball.set_speed(2)

         return True

      if math.hypot(ball.position_x - self.point.x, ball.position_y \
            - self.point.y) < ball.radius + self.hole_radius :

         ball.set_ball_in_hole(True)

      return False


