
# Tikku-luokan tarkoituksena on piirtaa viiva valkoisesta pallosta
# hiiren osoittimeen. Lisaksi tikkuluokka piirtaa tikun pallon toisellepuolelle
# ja siirtaa sita voiman mukaan.
# Luokka antaa valkoiselle pallolle voiman ja suunnan

import gtk
import sys
from Point import Point
from GeneralPath import GeneralPath
import math

class Stick :

   #Point stick_point
   #GeneralPath stick
   #strength
   #distance_from_the_ball = 0
   #radian
   #is_shooted = False

   def __init__(self) :
      #debug
      self.radian = 0
      self.strength = 0
      self.stick_point = Point(0,0)
      self.distance_from_the_ball = 0
      self.is_shooted = False
      #self.create_stick()

   def create_stick(self) :

      self.stick = GeneralPath()
      x =  [10, 250, 250, 10]
      y =  [-2, -5, 5, 2]

      self.stick.moveTo(x[0], y[0])
      for index in range(1, len(x)) :

         self.stick.lineTo(x[index], y[index])

      self.stick.closePath()

   def draw(self, drawing_area, ball) :

      graphics_context  = drawing_area.get_style().fg_gc[gtk.STATE_NORMAL]
      this_drawable  =  drawing_area.window

      if self.stick_point.x != 0 and \
         self.stick_point.y != 0 and \
         self.is_shooted == False :

         #graphics2D.setColor(new Color(25, 100, 20, 255))(6400, 25600, 5120, 0)
         #graphics2D.drawLine(stick_point.x, stick_point.y, (int) (ball
         #      .position_x - math.cos(radian) * 10), (int) (ball
         #      .position_y - math.sin(radian) * 10))
         #graphics2D.setColor(Color.darkGray.darker())
         #graphics2D.fill(stick)

         graphics_context.set_rgb_fg_color(gtk.gdk.Color(6400, 25600, 5120, 0))
         this_drawable.draw_line(graphics_context, self.stick_point.x,
                                 self.stick_point.y,
                             int(ball.position_x - math.cos(self.radian) * 10),
                             int(ball.position_y - math.sin(self.radian) * 10))

         #graphics_context.set_rgb_fg_color(gtk.gdk.Color(55600, 55600, 55600, 0))
         #self.stick.draw(drawing_area)

   def moveStick(self, a_stick_point, ball) :

      #self.create_stick()
      self.stick_point = a_stick_point

      # LASKETAAN TIKUN KULMA
      self.radian = math.atan2(ball.position_y - self.stick_point.y,
                               ball.position_x - self.stick_point.x)

      # PYORITELLAAN TIKKU PAIKOILLEEN
      #AffineTransform at = AffineTransform()
      #at.translate(ball.position_x, ball.position_y)
      #at.rotate(self.radian)
      #self.stick.transform(at)

      # ASETETAAN KULMA PALLOLLE
      ball.set_radian(math.atan2(self.stick_point.y - ball.position_y,
                                 self.stick_point.x - ball.position_x))

      self.is_shooted = False


   def shoot(self, ball) :

      #debug
      self.distance_from_the_ball = -1

      if self.distance_from_the_ball <= 0 :

         ball.set_speed(self.strength)
         self.strength = 0
         self.is_shooted = True
         return True

      else :

         self.distance_from_the_ball -= self.strength / 4
         self.is_shooted = False

         stick_moving_distance = self.strength / 4

         if self.distance_from_the_ball < 0 :

            self.distance_from_the_ball = 0
            stick_moving_distance = 0

         #else  :

            #AffineTransform at_distance_from_the_ball = AffineTransform()
            #at_distance_from_the_ball.translate( \
            #            -stick_moving_distance * math.cos(self.radian),
            #            -stick_moving_distance * math.sin(self.radian))
            #self.stick.transform(at_distance_from_the_ball)

      return False

   def set_strength(self, a_strength) :

      self.distance_from_the_ball = a_strength
      #AffineTransform at_strength = new AffineTransform()

      # tikku irti pallosta
      #at_strength.translate((a_strength - self.strength) * math.cos(self.radian),
      #                      (a_strength - self.strength) * math.sin(self.radian))
      #self.stick.transform(at_strength)

      self.strength = a_strength



