
# Table-luokka piirtaa pelialueen
# seka hallitsee hole- ja edge-luokkia

import gtk
from Hole import Hole
from Edge import Edge

class Table :

   def __init__(self, a_table_position_x, a_table_position_y) :

      self.table_position_x = a_table_position_x + 30
      self.table_position_y = a_table_position_y

      # LUODAAN REIAT
      self.holes = []
      self.holes += [Hole(1, self.table_position_x, self.table_position_y)]
      self.holes += [Hole(2, self.table_position_x + 300, self.table_position_y)]
      self.holes += [Hole(3, self.table_position_x + 600, self.table_position_y)]
      self.holes += [Hole(4, self.table_position_x, self.table_position_y + 300)]
      self.holes += [Hole(5, self.table_position_x + 300, self.table_position_y + 300)]
      self.holes += [Hole(6, self.table_position_x + 600, self.table_position_y + 300)]

      # LUODAAN TARMAYSSEINAT
      self.edges = []
      self.edges += [Edge(self.table_position_x, self.table_position_y, "TOP1")]
      self.edges += [Edge(self.table_position_x, self.table_position_y, "TOP2")]
      self.edges += [Edge(self.table_position_x, self.table_position_y, "BOTTOM1")]
      self.edges += [Edge(self.table_position_x, self.table_position_y, "BOTTOM2")]
      self.edges += [Edge(self.table_position_x, self.table_position_y, "LEFT")]
      self.edges += [Edge(self.table_position_x, self.table_position_y, "RIGHT")]



   #def draw(Graphics graphics)

      #Graphics2D graphics2D = (Graphics2D) graphics

   def draw(self, drawing_area) :

      graphics_context  = drawing_area.get_style().fg_gc[gtk.STATE_NORMAL]
      this_drawable  =  drawing_area.window

      # PIIRRETAAN REUNAT
      #graphics2D.fillRect(table_position_x - 30, table_position_y - 30, 660, 360)
      graphics_context.set_rgb_fg_color(gtk.gdk.Color(32768, 16384, 0, 0))
      this_drawable.draw_rectangle(graphics_context,True,
                                   self.table_position_x - 30,
                                   self.table_position_y - 30,
                                   660, 360)

      # PIIRRETAAN PELIALUE
      #graphics2D.setColor(new Color(27, 130, 28, 255))
      #graphics2D.fill(new Rectangle(table_position_x, table_position_y, 600, 300))

      graphics_context.set_rgb_fg_color(gtk.gdk.Color(6912, 33280, 7168, 0))
      this_drawable.draw_rectangle(graphics_context,True,
                                   self.table_position_x, self.table_position_y,
                                   600, 300)

      # PIIRRETAAN REIAT JA TORMAYSSEINAT
      for index in range(len(self.edges)) :

         # PIIRRETAAN TORMAYSSEINAT
         self.edges[index].draw(drawing_area)

      # PIIRRETAAN REIAT JA TORMAYSSEINAT
      for index in range(len(self.holes)) :

         # PIIRRETAAN REIAT
         self.holes[index].draw(drawing_area)

      #debug (tama on se alue jonka ulkopuolella pallojen tormaykset tutkitaan)
      #graphics_context.set_rgb_fg_color(gtk.gdk.Color(0, 0, 0, 0))
      #this_drawable.draw_rectangle(graphics_context,False,59 + 9 ,69 + 9, 580 - 18, 280 - 18)





